!> \file climat-forcage-eurasie_mod-0.4.f90
!! Module de calcul du forcage climatiques
!<

!> \namespace  climat_forcage_eurasie_mod
!! Calcule du forcage climatiques
!! \author ...
!! \date ...
!! @note Used module
!! @note   - use module3D_phy
!! @note   - use printtable
!<


module climat_forcage_eurasie_mod

!!!!!!!!!!!!!!!!!!!!=1=decalaration variables================!!!!!!!!!!!!!!!!!!!!

       use module3D_phy
       use printtable
implicit none

integer nft					!< NFT est le nombre de lignes a lire dans le fichier contenant le forcage climatique
real,dimension(:),allocatable :: TDATE          !< time for climate forcing
real,dimension(:),allocatable :: alphaT
real,dimension(:),allocatable :: alphaP
real,dimension(:),allocatable :: SPERT
integer,parameter :: ntr=4 			!< nb of snapshot files !ntr is now explicitely specified in the climat module
 
REAL ttr(ntr)!< la date des tranches (snapshots)  (len=ntr) 
REAL alphaTTR(ntr) !< Le alphaT de l'index glaciologiq. aux snapshots
REAL delTa(nx,ny,ntr),delTj(nx,ny,ntr),rapact(nx,ny,ntr)
REAL  delTatime(nx,ny),delTjtime(nx,ny),rapactime(nx,ny)
integer  lake(nx,ny)
character(len=100) :: filin
CHARACTER(LEN=120) filtr(ntr)
!CHARACTER(LEN=80),dimension(ntr)::  filtr   !snapshot file name (len=ntr)

contains
!!!!!!!!!!!!!!!!!!!!=2=lecure des input=s====================!!!!!!!!!!!!!!!!!!!!

!> SUBROUTINE: input_clim
!!Routine qui permet d'initialiser les variables climatiques
!<

  subroutine input_clim !routine qui permet d'initialiser les variables climatiques
    USE module3D_phy

    implicit none
    character(len=8) :: control!label to check clim. forc. file (filin) is usable
    integer :: l !In snapshot files:the first column is the mask, read but not used

    delTatime(:,:)=0.
    delTjtime(:,:)=0.
    rapactime(:,:)=1.

    !====================================================heminor============
    if (geoplace.eq.'heminor') then

       !     atmospheric temperature gradient
       TEMPGRAD=0.008
       TEMPGRJUL=0.0065


       !Pou le nord cette pariti est copie de inputfile-hemicycle.f (3juin04)
       ! 1_fichiers snapshots pour forcage
       !----------------------------------
       filtr(1)=TRIM(DIRNAMEINP)//'FORCAGES/forcLGM-lmd5prese.g50'
       filtr(2)=TRIM(DIRNAMEINP)//'FORCAGES/forcLGM-lmd5futur.g50'
       !           filtr(1)=TRIM(DIRNAMEINP)//'FORCAGES/forcage-100k-actu.g50'
       !           filtr(1)=TRIM(DIRNAMEINP)//'FORCAGES/forcage-80k-115END.g50'
       !           filtr(2)=TRIM(DIRNAMEINP)//'FORCAGES/forcage-50k-LGM.g50'
       !           filtr(2)=TRIM(DIRNAMEINP)//'FORCAGES/forcage-50k-115END.g50'
       !           filtr(3)=TRIM(DIRNAMEINP)//'FORCAGES/forcage-21k.g50'
       !           filtr(4)=TRIM(DIRNAMEINP)//'FORCAGES/forcage-15k.g50'
       !           filtr(5)=TRIM(DIRNAMEINP)//'FORCAGES/forcage-09k.g50'
       !           filtr(6)=TRIM(DIRNAMEINP)//'FORCAGES/forcage-06k.g50'
       !           filtr(7)=TRIM(DIRNAMEINP)//'FORCAGES/forcage-00k.g50'
       ! 2_fichiers donnant l'evolution temporelle
       ! -------------------HEMICYCLE ------------
       ! lecture du fichier scalaire (sea level)
       !        filin=TRIM(DIRNAMEINP)//'heminor-forcLGM.dat'
       filin=TRIM(DIRNAMEINP)//'signal-cycle-hemin.dat'
!!!this file contains TDATE(I),alphaT(I),alphaP(i),SPERT(I),I=1,nft         
       !====================================================hemin40============
    elseif (geoplace.eq.'hemin40') then

       !     atmospheric temperature gradient
       TEMPGRAD=0.008
       TEMPGRJUL=0.0065

       ! 1_fichiers snapshots pour forcage
       !----------------------------------
       filtr(1)=TRIM(DIRNAMEINP)//'FORCAGES/forcage_hemin40-21k.g40'
       filtr(1)=TRIM(DIRNAMEINP)//'FORCAGES/file_regions_.g40'
       filtr(1)=TRIM(DIRNAMEINP)//'FORCAGES/file_regions_2.g40'

       filtr(2)=TRIM(DIRNAMEINP)//'FORCAGES/file_regions_2act.g40'

       ! 2_fichiers donnant l'evolution temporelle
       ! -----------------------------------------
       filin=TRIM(DIRNAMEINP)//'signal-cycle-hemin.dat'
       !====================================================eurasie============
    elseif (geoplace.eq.'euras40') then

       !     atmospheric temperature gradient
       !       TEMPGRAD=0.008
       !       TEMPGRJUL=0.0065
       TEMPGRAD=0.006 ! Pour Serie 2 (grad T reduit)
       TEMPGRJUL=0.005
       ! 1_fichiers snapshots pour forcage
       !      filtr(1)=TRIM(DIRNAMEINP)//'FORCAGES/forcage_eur_froid90k.dat'
       !     filtr(1)=TRIM(DIRNAMEINP)//'FORCAGES/forcage_eur_tres_froid.dat'
       !     filtr(1)=TRIM(DIRNAMEINP)//'FORCAGES/forcage_EUR_TRES_froid90k.dat'
       !     filtr(1)=TRIM(DIRNAMEINP)//'FORCAGES/forcage_EGU6_TRES_froid90k.dat'
       !     filtr(1)=TRIM(DIRNAMEINP)//'FORCAGES/forc_ger_90ka_eur40.dat'
       filtr(1)=TRIM(DIRNAMEINP)//'FORCAGES/forcage_ger_.dat'
       !     filtr(2)=TRIM(DIRNAMEINP)//'FORCAGES/forcage_eur_lim_incep0k.dat'
       filtr(3)=TRIM(DIRNAMEINP)//'FORCAGES/forcage_eur_no_forca.dat' ! climat act
       filtr(3)=TRIM(DIRNAMEINP)//'FORCAGES/forcage_gerhard_0ka.dat' ! climat act simule
       !     filtr(1)=TRIM(DIRNAMEINP)//'FORCAGES/forcage_95ka_mod.dat'
       !     filtr(2)=TRIM(DIRNAMEINP)//'FORCAGES/forcage_95ka_mod.dat'   !  E6eurL02
       !     filtr(1)=TRIM(DIRNAMEINP)//'FORCAGES/forcage_95ka_nolak_mod.dat' !
       !     filtr(2)=TRIM(DIRNAMEINP)//'FORCAGES/forcage_95ka_nolak_mod.dat' ! E6eurN02 
       !3 snapshots
       !    filtr(1)=TRIM(DIRNAMEINP)//'FORCAGES/forcage_gerhard_105ka.dat' ! climat act simule
       !    filtr(2)=TRIM(DIRNAMEINP)//'FORCAGES/forc_ger90_LA_se1mod.dat'
       !    filtr(3)=TRIM(DIRNAMEINP)//'FORCAGES/forcage_gerhard_85ka.dat' ! climat act simule
       !4 snapshots
       filtr(1)=TRIM(DIRNAMEINP)//'FORCAGES/forcage_gerhard_105ka.dat' ! climat act simule
       !     filtr(1)=TRIM(DIRNAMEINP)//'FORCAGES/forcage_eur_no_forca-k105.dat'
       !     filtr(2)=TRIM(DIRNAMEINP)//'FORCAGES/forc_ger95-4A_LA_se1mod.dat'
       !     filtr(2)=TRIM(DIRNAMEINP)//'FORCAGES/forR_ger95-4A_LA_se1mod.dat'
!!!   filtr(2)=TRIM(DIRNAMEINP)//'FORCAGES/forR_ger95-2A_LA_se1mod.dat'
       filtr(2)=TRIM(DIRNAMEINP)//'FORCAGES/forc_ger95-1A_LA_se2mod.dat'
       !     filtr(2)=TRIM(DIRNAMEINP)//'FORCAGES/forc_ger95-1A_NL_se2mod.dat'
       filtr(3)=TRIM(DIRNAMEINP)//'FORCAGES/forc_ger90_LA_se2mod.dat'
       !     filtr(3)=TRIM(DIRNAMEINP)//'FORCAGES/forc_ger90_NL_se2mod.dat'
       filtr(4)=TRIM(DIRNAMEINP)//'FORCAGES/forcage_gerhard_85ka.dat' ! climat act simule
       !     filtr(4)=TRIM(DIRNAMEINP)//'FORCAGES/forcage_eur_no_forca-k85.dat'
       ! NO LAKES
       !     filtr(2)=TRIM(DIRNAMEINP)//'FORCAGES/forcage_ger_mod_nolake.dat'
       !     filtr(:)=TRIM(DIRNAMEINP)//'FORCAGES/forc_ger95-1A_LA_se2mod.dat'
       !      filtr(:)=TRIM(DIRNAMEINP)//'FORCAGES/forc_ger90_NL_se2mod.dat'
       !
       !     filtr(2)=TRIM(DIRNAMEINP)//'FORCAGES/forcage_95ka_noalb_mod.dat' ! E6eurL01
       ! 2_fichiers donnant l'evolution temporelle
       filin=TRIM(DIRNAMEINP)//'signal-seal_i_inso_90ka.data'
       filin=TRIM(DIRNAMEINP)//'signal-sealev_inso_26jui06.dat'
       !       filin=TRIM(DIRNAMEINP)//'signal-cycle-hemin.dat'

!!!  filin=TRIM(DIRNAMEINP)//'signal-sealev_index_inso.data'
       !    filin=TRIM(DIRNAMEINP)//'signal-sealev_index_inso_art.data'
!!!  filin=TRIM(DIRNAMEINP)//'signal-sealev_index_inso_art2.dat'

       !====================================================ant20 et 40========
    elseif ((geoplace.eq.'anteis1').or.(geoplace.eq.'ant20km')) then


       !     atmospheric temperature gradient
       TEMPGRAD=0.0085
       TEMPGRJUL=0.0085

       ! 1_fichiers snapshots pour forcage
       !----------------------------------
       filtr(1)='../INPUT-DATA/FORCAGES/forcage-ant-20k.g40'
       filtr(2)='../INPUT-DATA/FORCAGES/forcage-ant-00k.g40'
       print*,'lecture de ',filin,filtr
       ! 2_fichiers donnant l'evolution temporelle
       ! ---------------------------- ------------
       filin=TRIM(DIRNAMEINP)//'forcmodif4cycles.dat' !forcage vostok en rapport : a creer

    endif !Fin du test sur geolpace

    ! 3_lecure des fichiers snapsots pour tout geoplace
    ! -------------------------------------------------
    write(6,*) 'fichiers snapshots'
    do k=1,ntr
       write(6,*) filtr(k)
       open(20,file=filtr(k))
       read(20,*) ttr(k)
       read(20,*)
       read(20,*)
       do j=1,ny
          do i=1,nx
             !              read(20,*) l,rapact(i,j,k),delTa(i,j,k),delTj(i,j,k)
             read(20,*) delTa(i,j,k),delTj(i,j,k),rapact(i,j,k)
          end do
       end do
       close(20)
    end DO
    !       ttr(1)=-500000. !ttr est la date des tranches 3D-1.h
    !       ttr(2)=0
    ! 4_lecure des fichiers d'evolution pour tout geoplace
    ! ----------------------------------------------------
    open(20,file=filin,status='old')
    !        print*,nft
    read(20,*) control,nft
    print*,'control',control,nft
    ! Determination of file size (line nb), allocation of perturbation array
    if (control.ne.'nb_lines') then
       write(6,*) filin,'indiquer le nb de ligne en debut de fichier:'
       write(6,*) 'le nb de lignes et le label de control nb_lines'
       stop
    endif

    if (.not.allocated(tdate)) THEN
       allocate(TDATE(nft),stat=err)
       if (err/=0) then
          print *,"Erreur  l'allocation du tableau TDATE",err
          stop 4
       end if
    end if

    if (.not.allocated(alphat)) THEN
       allocate(alphaT(nft),stat=err)
       if (err/=0) then
          print *,"Erreur  l'allocation du tableau TPERT",err
          stop 4
       end if
    end if

    if (.not.allocated(alphap)) THEN
       allocate(alphap(nft),stat=err)
       if (err/=0) then
          print *,"Erreur  l'allocation du tableau TPERT",err
          stop 4
       end if
    end if

    if (.not.allocated(spert)) THEN
       allocate(spert(nft),stat=err)
       if (err/=0) then
          print *,"Erreur  l'allocation du tableau SPERT",err
          stop 4
       end if
    end if

    do I=1,NFT
       !          read(20,*) TDATE(I),alphaT(I),alphaP(i),SPERT(I) ! forc grip
       !          print*,i,TDATE(I),alphaT(I),alphaP(i),SPERT(I)
       read(20,*) TDATE(I),alphaT(I),SPERT(I)           ! forc inso
    end do
    !RAJOUT VINCE
    do k=1,ntr
       do I=1,NFT
          if (TDATE(I)==ttr(k)) then
             alphaTTR(k)=alphaT(I)      
          endif
       end do
    end do

    alphaP(:)=1.0
    !----------------------------masque de glace
    do j=3,ny-2
       do i=3,nx-2
          mk0(i,j)=1
          if ((i.lt.25).and.(j.gt.35)) mk0(i,j)=0
       end do
    end do

    print*, 'module forcage climatique'
    print*, 'ajout de lakes',TRIM(DIRNAMEINP)//'regions_lakes_eurasie40.ijk'
    !open(unit=1005,file=TRIM(DIRNAMEINP)//'regions_lakes_eurasie40.ijk')
    !open(unit=1005,file=TRIM(DIRNAMEINP)//'lak_reg40km_eu40_ij')
    !      read(1005,*)
    !      read(1005,*)
    !      read(1005,*)
    !       do j=1,ny
    !          do i=1,nx
    !            read(1005,*) k,k,lake(i,j)
    !          enddo
    !      enddo   
    !:

    ! A CREER ou organiser a partir des codes dans ! 2_fichiers donnant l'evolution temporelle

  end subroutine input_clim
!--------------------------------------------------------------------------------
!>SUBROUTINE: init_forclim
!!Initialisation des parametres climatiques
!<
subroutine init_forclim

!namelist/clim_forc/
!namelist/clim_pert/rappact,retroac,rapbmshelf,mincoefbmelt,maxcoefbmelt

!rewind(num_param)        ! pour revenir au debut du fichier param_list.dat
!read(num_param,clim_forc)

! formats pour les ecritures dans 42
428 format(A)

write(num_rep_42,428)'!___________________________________________________________' 
write(num_rep_42,428) '&clim_forc_euras ! pour le forcage climatique par snapshots'
write(num_rep_42,*)
end subroutine init_forclim
!---------------------------------------------------------------------
!forcage climatique au cours du temps

!>SUBROUTINE: forclim
!!Forcage climatique au cours du temps
!<

subroutine forclim

  implicit none
  real COEFT,COEFP,coeftime!coeftime is not used
  INTEGER L !dumm index for loops on snapsots files  l=ITR,NTR-1
  INTEGER ITR !nb of the current snapshot file (change with time)
!       time en dehors des limites du fichier forcage
INTEGER ii,jj
              ITR=1

if(time.le.tdate(1)) then   ! time avant le debut du fichier forcage
   sealevel=spert(1)
   coeft=alphat(1)
   coefp=alphap(1)
   ift=1

else if (time.ge.tdate(nft)) then     ! time apres la fin du fichier forcage
   sealevel=spert(nft)
   coeft=alphat(nft)
   coefp=alphap(nft)
   ift=nft

else


!A modifier
    ift = 1      ! modifie par SC le 24/11/99
   do i=ift,nft-1
!       print*,'ds boucle1 sur snapshots',ift,TDATE(I),TDATE(I+1),time 
          if((time.ge.tdate(i)).and.(time.lt.tdate(i+1))) then

!        interpolation entre I et I+1 : cas general
!           TAFOR=TPERT(I)+(TPERT(I+1)-TPERT(I))*
!    &            (time-TDATE(I))/(TDATE(I+1)-TDATE(I))
          SEALEVEL=SPERT(I)+(SPERT(I+1)-SPERT(I))*    &
                 (time-tdate(I))/(tdate(I+1)-tdate(I))

          coeft=alphaT(I)+(alphaT(I+1)-alphaT(I))*      &
                 (time-tdate(I))/(tdate(I+1)-tdate(I))

!          COEFP=alphaP(I)+(alphaP(I+1)-alphaP(I))*      &
!                 (time-TDATE(I))/(TDATE(I+1)-TDATE(I))

                 do k=1,ntr-1  
                   if((time.ge.ttr(k)).and.(time.lt.ttr(k+1))) goto 105

                 enddo
105  continue

if (k==ntr) k=ntr-1
!Rajout Vince 26 juin 2006
! coefbmshelf est donn avec l'index d'insolation  65N
          coefbmshelf=coefT
!On retablit l'index entre 

                  if((time.ge.ttr(1)).and.(time.lt.ttr(ntr))) then
                      coeft  =   ( coeft - alphaTTR(k) ) / &
                           ( alphaTTR(k+1)-alphaTTR(k) )
                  else
                      print*,'on est pas dans les priodes forc'
                      print*,'les bornes sont ttr(1) et ttr(ntr)',ttr(1),ttr(ntr)
                      print*,'time=',time
                      stop
                  endif



! Pour les experiences eurasiennes coefp==coeft
          COEFP=COEFT
!        SEALEVEL=-50.         
            IFT=I
            goto 100
          endif

        end do
      endif
100   continue

!          print*,'coeffT P',COEFT,COEFP
!=forcage du climat
!       time en dehors des limites du fichier forcage
        if(time.le.Ttr(1)) then   ! mis a -500 000 ans
          do j=1,ny
            do i=1,nx
              delTatime(i,j)=delTa(i,j,1)
              delTjtime(i,j)=delTj(i,j,1)
              rapactime(i,j)=rapact(i,j,1)
            end do
           end do
              ITR=1
        else if (time.ge.ttr(Ntr)) then        ! mis a 0
          do j=1,ny
            do i=1,nx
             delTatime(i,j)=delTa(i,j,ntr)
             delTjtime(i,j)=delTj(i,j,ntr)
             rapactime(i,j)=rapact(i,j,ntr)
            end do
           end do
           ITR=NTR
        else               !  interpolation entre l et l+1 : cas general

        itr=max(itr,1)
       WRITE(6,*)'itr = !',itr


!parametres du fit
        do l=ITR,NTR-1
        print*,'ds boucle2 sur snapshots',l,ttr(l) 
           if((time.ge.ttr(l)).and.(time.lt.ttr(l+1))) then  ! test tranche

           coeftime= (time-TTR(l))/(TTR(l+1)-TTR(l))
           do j=1,ny
            do i=1,nx
            delTatime(i,j)=delTa(i,j,l)+             &
               (delTa(i,j,l+1)-delTa(i,j,l))*coefT

            delTjtime(i,j)=delTj(i,j,l)+             &
               (delTj(i,j,l+1)-delTj(i,j,l))*coefT

            rapactime(i,j)=rapact(i,j,l)+            &
               (rapact(i,j,l+1)-rapact(i,j,l))*coefP
             end do
           end do
              print*,'l= ',l,delTj(40,30,l),delTj(40,30,l+1),delTjtime(40,30)
           ITR=l
            goto 200

            endif        ! fin du test sur la tranche
         end do
       endif   ! fin du test avant,apres,milieu

200   continue
print*,'l= ',l,'itr= ',itr
!     sortie pour verifier les valeurs
!      print*,time ,coefT,coefP,sealevel
!0print*,'dans le forclim climat coefbmshelf nest pas defini'
!! coefmshelf est un coefficient qui fait vairier bmgrz et bmshelf
!! en fonction de TAFOR (deplace depuis icetemp 16juin2004(au LSCE))
!! coefbmshelf=(1.+TAFOR/10.)    ! coefbmshelf=0 pour TAFOR=-10deg
!           do j=60,120!1,ny
!            do i=50,100 !1,nx
!                 if ((flot(i,j).and.time.lt.130000).and.  &
!                     .not.(i.gt.75.and.j.lt.75)) then
!                   delTjtime(i,j)=delTjtime(i,j)-4.
!                   delTatime(i,j)=delTatime(i,j)-4.
!                endif
!             end do
!           end do

!    delTatime=-8.
!    delTjtime=-8. 
!    sealevel=-50.
!    TAFOR=delTatime(90,100)
! coefbmshelf=(1.+TAFOR/7.)    ! coefbmshelf=0 pour TAFOR=-7deg standard
!do j=1,ny  
! do i=1,nx    
!    if ( (S0(i,j).eq.0.) .and. (S(i,j).gt.sealevel) .and. (ICE(i,j)==0) ) then !exp B
!    if ( (S0(i,j).eq.0.) .and. (S(i,j).gt.sealevel) ) then !exp d
!          if (j.lt.55.and.i.gt.35) then
!         else        
!        delTjtime(i,j)=delTjtime(i,j)+5.
!         endif
!    endif
! enddo
!enddo 
!NIVEAU DES MERS ET DES LAKES
     
if ((time.lt.-95000.).or.(time.gt.-85500.)) then ! time SANS lacs
                levelflot=sealevel
else
   do j=1,ny  
     do i=1,nx    
!!if (ice(i,j)==1) delTjtime(i,j)=delTjtime(i,j)-3. ! correction effet albedo
!             if ( lake(i,j)==2 ) then     !KOMI
!               levelflot(i,j)=100.
!             elseif ( lake(i,j)==3 ) then !SIBERIAN
!               levelflot(i,j)=60.
!               if ((.not.flot(i,j)).and.(flot(i+1,j)) ) print*,i,j,h(i,j),bmelt(i,j)
!            else
!               levelflot(i,j)=sealevel        
!            endif
             levelflot(i,j)=-60.
     enddo
   enddo 
endif
     levelflot(:,:)=max(levelflot(:,:),bsoc(:,:))
   nom_table='flot'
   call printtable_l(flot,nom_table)
   nom_table='lvflo'
   call printtable_r(levelflot,nom_table)
    
!   coefbmshelf(:,:)=(1.+delTatime(:,:)/7.)  
!coefbmshelf=1. ! modif pour test de sensibilite (tof 20 avril 01)
!coefbmshelf=coefT
    coefbmshelf=max(coefbmshelf,0.1)
    coefbmshelf=min(coefbmshelf,2.)
tafor=delTjtime(40,30)   

print*,'time, coefbmshelf ',time, coefbmshelf
print*,'SEA,COEFT,COEFP', SEALEVEL,COEFT,COEFP
!rint*,'= t,sea,tafor',time,sealevel,tafor
print*,'==========================='
if ((geoplace(1:5).eq.'hemin').or.(geoplace(1:5).eq.'euras')) then        
call accum7() ! ds le main
call ablation_2007pey_et_al()
!forcage stationnaire
!      open(111,file='ger/tjja_90LA_EURAS40.ijk')
!      open(112,file='ger/tann_90LA_EURAS40.ijk')
!      open(113,file='ger/mb_90LA_EURAS40.ijk')
!      open(114,file='ger/melt_90LA_EURAS40.ijk')
!      do J=1,NY
!       do I=1,NX
!!      print*,i,j
!       read(111,*) ii,jj,Tjuly(i,j)
!!       print*,ii,jj,Tjuly(i,j)
!       read(112,*) ii,jj,Tann(i,j)
!       read(113,*) ii,jj,BM(i,j)
!       read(114,*) ii,jj,abl(i,j)
!          if (Tjuly(i,j).lt.5.) then      
!            acc(i,j)=BM(i,j)-abl(i,j)
!          else
!            BM(i,j)=.0
!          endif
!       end do
!      end do
!      close(111) ;  close(112) ; close(113); close(114) 
!forcage stationnaire      
elseif ((geoplace.eq.'anteis1').or.(geoplace.eq.'ant20km')) then
! call n'est plus dans le main
!call massb_anteis_forcage()
!call ablation()
else
 print*,"partie en travaux climat forcage auter que sur heminord"
 print*,"geoplace ",geoplace
endif
! call bla2
! call bla3

END subroutine forclim

end module climat_forcage_eurasie_mod
